import {
  Http, IDictionary,
} from '@zeedhi/core';
import {} from '@zeedhi/common';

export class HierarquiasController {
  // Objeto com usuários da hierarquia
  public gridInfo: IDictionary[] = [];

  // Id's, dos usuários da ramificação abaixo do userlogado
  public lowerHierarchyUsers: IDictionary = [];

  // Busca o ID(nr) da hierarquia ativa e salva no local storage
  public getActiveHierarchyId() {
    Http.get('/getActiveHierarchyId').then((response: IDictionary) => {
      const nrhierarquiafunc = response.data.dataset.info[0].NRHIERARQUIAFUNC;
      window.localStorage.setItem('nrhierarquiafunc', nrhierarquiafunc);
    });
  }

  // Monta o array de usuários da ramificação abaixo
  public async mountHierarchyUsersArray() {
    const id = localStorage.getItem('nrhierarquiafunc');
    const nrfuncionario = localStorage.getItem('UserLogado'); // mandar esse userlogado na primeira chamada

    await Http.get(`/getHierarchyDetails?nrhierarquiafunc=${id}`).then((response: IDictionary) => {
      this.gridInfo = [];
      response.data.dataset.info.forEach((database: IDictionary) => {
        this.gridInfo.push({
          userId: database.NRFUNCIONARIO,
          userName: database.NMFUNCIONARIO,
          userParent: database.NRFUNCIONARIOPAI,
          hierarchyId: database.NRFUNCIONARIOSHIERARQ,
        });
      });
      this.lowerHierarchyUsers = [];
    });

    this.gatherLowerHierarchyUsers(Number(nrfuncionario));
    return this.lowerHierarchyUsers;
  }

  // Salva no array os usuários daquela ramificação
  public gatherLowerHierarchyUsers(nrfuncionario: number) {
    this.lowerHierarchyUsers.push(nrfuncionario);

    this.gridInfo.forEach((user: IDictionary) => {
      if (nrfuncionario === user.userParent) this.gatherLowerHierarchyUsers(user.userId);
    });
  }
}
